#include "../include/common.h"
#include "../include/subs.h"
#include "../include/integrate.h"


//eine Trajektorie
void betrachter(ex &apunkt, ex &ppunkt, double Omegaval, double Aval, double step, long points, double starta, double startp)
{
	ex ap = subs(apunkt,Omegaval,Aval);
	ex pp = subs(ppunkt,Omegaval,Aval);
	integrate(cout,ap,pp,starta,startp,step,points);
}

//Hier wird nun die Lage fuer einen Satz von (Omega,A) betrachtet
void betrachter(ex &poti, ex &apunkt, ex &ppunkt, double Omegaval, double Aval, double step, long points, long starts)
{
	//basteln eines passenden Verzeichnisses
	ostringstream dirname;
	dirname << Omegaval << '_' << Aval;
	mkdir(dirname.str().c_str(), 0777);
	
	//das Potential in eine Datei...
	ostringstream filename;
	filename << dirname.str() << '/' << "poti"; 
	ofstream nf(filename.str().c_str());
	nf << subs(poti,Omegaval,Aval) << endl;
	nf.close();

	//Nun zum Phasenportrait; dazu sollen sich die schon in main() abgeleiteten Bewegungsgleichungen etwas entwickeln.
	//Dazu werden zuerst natrlich die Parameter eingesetzt.
	ex ap = subs(apunkt,Omegaval,Aval);
	ex pp = subs(ppunkt,Omegaval,Aval);
	cout << "integriere: ap = " << ap << "; pp = " << pp << endl; 

	//Und nun die Schleife:
	//Hundert Trajektorien vermitteln hoffentlich einen Eindruck.
	//101 starts -> hundertstel schritte
	// 2 starts -> eintel...
	for(int i = 0; i < starts; ++i)
	{
		//Start bei alpha=0 und p zwischen -10 und 10
		double p = -10+(starts > 1 ? i*(double)20/(starts-1) : 0);
		cout << "p = " << p << endl;
		//passende Datei
		filename.str("");
		filename << dirname.str() << "/traj_0_" << p << ".dat";
		cout << filename.str() << endl;
		nf.open(filename.str().c_str()); //oeffnen der Datei - integrate() bekommt den Stream
		//Berechnen von Bahnpunkten der Gleichungen ap und pp, startend bei alpha=0 und p
		integrate(nf,ap,pp,0,p,step,points);
		nf.close(); //schlieen
	}
}
