#!/bin/perl

use FindBin qw($Bin);
use lib $Bin;
use Param;
use File::Spec::Functions qw(catfile splitpath splitdir abs2rel) ;


my $p = Param::Parse
(
	{'info','Ich erstelle die verschiedenen Plotskripte und evtl. auch die Bilder dazu (eps und png)... Verzeichnisse knnen auch einfach nach dem Kommando genannt werden (zustzlich zu --data parameter).'},
	[
		'data', '"data","dissdata"', 'd', 'Verzeichnis(se) mit den Quelldaten',
		'bilder', 0, 'b', 'Bilder mit erstellen (eps, kleines und groes png)',
		'epsweg', 1, 'e', 'die eps-Bilder wieder lschen (sind doch recht gross...)'
	]
);

$p->{data} =~ s/^([^"].*[^"])$/"$1"/;
@data = eval("($p->{data})");

foreach my $d (@data)
{
	next unless -d $d;
	my $plotdir = catfile($d,'plots');
	unless(-d $plotdir){ mkdir($plotdir) or die "Kann $plotdir nicht erstellen ($!)!\n"; }
	my $potisplot = catfile($plotdir,'potis.gnuplot');
	open(ADAT,">$potisplot") or die "darf nicht schreiben ($!)?\n";
	print ADAT "set title 'Potentiale auf einen Blick ({/Symbol W}; A)'\nset key outside\nset pm3d\nunset colorbox\n";
	my $axiss = "set xlabel '{/Symbol a} / {/Symbol p}'; set ylabel 'V / arb.U.'; set xrange[-1:1]\n";
	my $samples = "set samples 1000\n";
	print ADAT $axiss,$samples;
	print ADAT "plot";

	my $notfirst = -1;

	foreach my $f ( glob( catfile($d,'*') ) )
	{
		my ($volume,$directories,$file) = splitpath($f, 1); 
		my @dirs = splitdir($directories);

		if(-d $f and $dirs[$#dirs] =~ m:^([\d\.]+)_([\d\.]+)$:)
		{
			my ($O,$A) = ($1,$2);
			my $plotsdir = catfile($plotdir,$dirs[$#dirs]);
			unless(-d $plotsdir){ mkdir($plotsdir) or die "Kann $plotsdir nicht erstellen ($!)!\n"; }

			print STDERR "Omega = $O, A = $A\n";

			#einlesen der Potentialformel
			open(DAT, catfile($f,'poti')) or die "open?\n";
			my $func = <DAT>; chomp($func);
			close(DAT);

			#das sollte fr unsere Potentiale reichen
			$func =~ s/\^/**/g; 
			$func =~ s/alpha/x*pi/g;
			print STDERR "Potential: $func\n";
			my $of = catfile($plotsdir,'poti.gnuplot');
			open(DAT,">$of") or die "Schreiben von $of ($!)!?\n";
			print DAT "set title 'Potential fuer {/Symbol W} = $O und A = $A'; unset key\n";
			print DAT $axiss,$samples;
			print DAT "plot $func w l\n";
			close(DAT);
			Maler($of) if($p->{bilder});

			#alle potis
			print ADAT ", \\\n" if ++$notfirst;
			print ADAT " $func w l lt rgb '#".sprintf('%02x',int(256*rand())).sprintf('%02x',int(256*rand())).sprintf('%02x',int(256*rand()))."' title '$O; $A'";

			#phasenportrait
			$of = catfile($plotsdir, "portrait.gnuplot");
			open(DAT,">$of") or die "Schreiben von $of ($!)!?\n";
			print DAT $samples;
			print DAT "set xlabel '{/Symbol a} / {/Symbol p}'; set ylabel 'V bzw. p_{/Symbol a} in angepassten Einheiten'; set xrange[-1:1]; set yrange[-10:10]\nunset colorbox\nunset key\n";
			print DAT "plot \\\n";
			foreach my $t ( glob( catfile($f,'traj*.dat') ) )
			{
				print DAT "'",abs2rel( $t, $plotsdir ),"' w d lt rgb '#000000',\\\n";
			}
			print DAT "$func w l lt rgb '#0000FF'\n";
			close(DAT);
			Maler($of) if($p->{bilder});
		}
	}
	close(ADAT);
	Maler($potisplot) if($p->{bilder});
}

sub Maler
{
	my $plot = shift;
	$plot =~ s/\.gnuplot$//;
	system("make \"${plot}.eps\" \"${plot}_klein.png\" \"${plot}_gross.png\"");
	unlink("${plot}.eps") if $p->{epsweg};
}
